//Programmed by Mostafa Torbjorn Berg (mostafaberg.com)
//Released under GPLv3
//Usage: sudo vfd text.txt
//

/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
      This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.  the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>
#include "16seg.h"	//16 seg encodings, you may add any other chars needed here
			//This also contains the VFD low level code.

int main(int argc,char **argv){

FILE* fp;
char buf[100];
if((fp = fopen(argv[1], "r")) == NULL) {
	printf("Cannot open file.\n");
	exit(1);
}

if(ioperm(pport, 1, 1)){	//Parallel port
	fprintf(stderr,"connection error %x\n",pport), exit(1);
}
	fscanf(fp, "%s", buf);
	int i = 0;
	while(i < strlen(buf) - 5){
		init_vfd();				//Inits our VFD, sending the first commands

		vfd_send_char(get_seg(buf[i]));		//Send Char 1 thru
		vfd_send_char(get_seg(buf[i+1]));	//
		vfd_send_char(get_seg(buf[i+2]));	//
		vfd_send_char(get_seg(buf[i+3]));	//
		vfd_send_char(get_seg(buf[i+4]));	//
		vfd_send_char(get_seg(buf[i+5]));	//Char 6 !

		usleep(500000);				//Some delay to control scroll speed
		end_vfd();				//Same as VFD init, but sends the Turn on command
	i++;
	}
return 0;
}
